//Librerias necesarias
#include <Servo.h>
#include <LiquidCrystal.h>
#include <DHT.h>
#include <Adafruit_Sensor.h>


//Pines utilizados

//LCD
#define pin_RS 8
#define pin_EN 9
#define pin_d4 4
#define pin_d5 5
#define pin_d6 6
#define pin_d7 7
#define pin_BL 10

//Sensores de temperatura y humedad
#define pin_sensorA 2
#define pin_sensorB 3
#define type_dht DHT22

//Servos
#define pin_servo1 3
#define pin_servo2 12

//definicion de variables
//botones
#define btnRIGHT  0
#define btnUP     1
#define btnDOWN   2
#define btnLEFT   3
#define btnSELECT 4
#define btnNONE   5
int lcd_key     = 0;
int adc_key_in  = 0;
int read_LCD_buttons();  // para leer los botones

//Valores de operacion
int goalTemp = 25; //temperatura de operacion segun la config inicial DEFAULT:25°C
int tiempoFunc = 1 ;

int paso1 = 0;
int paso2 = 0;
int ok = 0;

//sensores
int intervaloSensores = 2000;
int millisSensor1; //sensor 1
float hSensor1;
float tSensor1;
int millisSensor2; //sensor 2
float hSensor2;
float tSensor2;

//servos
int posDimmer1= 0;
int posDimmer2= 0;
int millisDimmer1; 
int millisDimmer2; 
int intervaloDimmers;

//Creacion de objetos
LiquidCrystal lcd( pin_RS,  pin_EN,  pin_d4,  pin_d5,  pin_d6,  pin_d7);
DHT dht1(pin_sensorA, type_dht);
DHT dht2(pin_sensorB, type_dht);
Servo servoMotor1;
Servo servoMotor2;

void setup() {
  Serial.begin(9600);

  //Inicio de Sensores, LCD y Servos
  dht1.begin();
  dht2.begin();
  lcd.begin(16, 2);  
  servoMotor1.attach(pin_servo1);
  servoMotor2.attach(pin_servo2);

  lcd.setCursor(0, 0);
  lcd.print("Preparando...");
  delay(3000);

  //Inicio contador del Arduino
  unsigned long currentMillis = millis();

  //Configuracion inicial
  configuracionInicial();
}

void loop() {
  printLCD();
  readSensors();
  dimmer1();
  dimmer2();
  moveFans();
}




//Lo que se muestra en la pantalla durante el secado
void printLCD() {
  lcd.clear();
  lcd.setCursor(0, 0);
  lcd.print("T=");
  lcd.setCursor(3, 0);  
  float t = dht.readTemperature();
  lcd.print(t);
  lcd.setCursor(0, 1);
  lcd.print("H=");
  lcd.setCursor(3, 1);  
  float h = dht.readHumidity();
  lcd.print(h);
  //Se debe agregar el tiempo de secado
  }


//_______________________CONFIGURACION_INICIAL_________________________________
//Funcion que setea el ciclo, temperatura objetivo, tiempo de operacion (usa botones)
void configuracionInicial(){
  while (paso1 = 0) { //setea la temperatura de la secadora
    lcd.clear();
    lcd.setCursor(0,0);
    lcd.print("Set temperature");// PONER UN MENSAJE EN EL ESPACIO 0,0 DEL DISPLAY
    lcd.setCursor(0,1);
    lcd.print(goalTemp);// temperatura de secado deseada
    lcd.print("C");
      if (read_LCD_buttons()== btnUP){
        //subir temperatura
         goalTemp++;
        }
      else if (read_LCD_buttons()== btnDOWN){ 
        //bajar temperatura
        goalTemp--;
        }
      else if(read_LCD_buttons()== btnSELECT){
        //terminar paso 1
        paso1 = 1;
        }
      else{
        return;
        }
    }
  
  while (paso2 = 0) { //setea el tiempo de funcionamiento de la maquina
    lcd.clear();
    lcd.setCursor(0,0);
    lcd.print("Set time");// PONER UN MENSAJE EN EL ESPACIO 0,0 DEL DISPLAY
    lcd.setCursor(0,1);
    lcd.print(tiempoFunc);// tiempo de secado deseado
    lcd.print("hrs");
    if (read_LCD_buttons()== btnUP){       
      //aumentar tiempo en 1hr
      tiempoFunc++;
      }
    else if (read_LCD_buttons()== btnDOWN){ 
      //disminuir tiempo en 1hr
      tiempoFunc= tiempoFunc-1;
      }
    else if(read_LCD_buttons()== btnSELECT){
      //terminar paso 2
      paso2 = 1;
      }
    else {
      return;
      }
    }
  
  if (paso1==1 & paso2==1){
  lcd.setCursor(0,0);
  lcd.print("Comenzando...");// PONER UN MENSAJE EN EL ESPACIO 0,0 DEL DISPLAY
  ok = 1;
  lcd.setCursor(0,1);
  }
  else{
    return;
  }

}

void readSensors(){
  unsigned long currentMillis = millis();

  //Leer dht1 (sensor1)
  if(currentMillis - millisSensor1 > intervaloSensores) {
    millisSensor1 = currentMillis;  
    //La lectura toma 250 milisegundos
    hSensor1 = dht1.readHumidity();
    tSensor1 = dht1.readTemperature();
    //Revisa datos obtenidos
    if (isnan(hSensor1) || isnan(tSensor1)) {
      Serial.println("Failed to read from DHT sensor 1!");
      return;
      }
   }
  
  //Leer dht2 (sensor2), análogo a lo anterior
  if(currentMillis - millisSensor2 > intervaloSensores) {
    millisSensor2 = currentMillis;
    hSensor2 = dht2.readHumidity();
    tSensor2 = dht2.readTemperature();
    if (isnan(hSensor2) || isnan(tSensor2)) {
      Serial.println("Failed to read from DHT sensor 2!");
      return;
      }
   }
}


//_______________________________MOVER DIMMERS__________________________________
void dimmer1(){
  unsigned long currentMillis = millis();
   if(currentMillis - millisDimmer1 > intervaloDimmers) {
     millisDimmer1 = currentMillis; 
     servoDimmer1.write(posDimmer1);
       if(tSensor2<goalTemp & posDimmer1<180){ //acá se controla el maximo del servo 1
        posDimmer1 = posDimmer1+5;
        servoDimmer1.write(posDimmer1);
       }
       else if(tSensor2>goalTemp){
        posDimmer1 = posDimmer1-5;
        servoDimmer1.write(posDimmer1);
        }
   }
}
void dimmer2(){                 // *** NOTA, EL SERVO 2 SOLO SE MUEVE SI EL SERVO 1 YA ESTÁ A TOPE**
  unsigned long currentMillis = millis();
   if(currentMillis - millisDimmer2 > intervaloDimmers){
     millisDimmer2 = currentMillis; 
     servoDimmer2.write(posDimmer2);
     
       if(tSensor2<goalTemp & posDimmer1== 180 & posDimmer2<180){ //acá se controla el maximo del servo 2, 
        posDimmer2 = posDimmer2 + 5;
        servoDimmer2.write(posDimmer2);
       }
       else if(tSensor2>goalTemp){
        posDimmer2 = posDimmer2 - 5;
        servoDimmer2.write(posDimmer2);
        }
   }
}

void moveFans(){
  return
}


//____________________________BOTONES___________________________
int read_LCD_buttons()  { 
  adc_key_in = analogRead(0);      // Leemos A0
  if (adc_key_in > 900) return btnNONE;     // Ningun boton pulsado 
  if (adc_key_in < 60)   return btnRIGHT; 
  if (adc_key_in < 200)  return btnUP;
  if (adc_key_in < 400)  return btnDOWN;
  if (adc_key_in < 600)  return btnLEFT;
  if (adc_key_in < 800)  return btnSELECT; 
  return btnNONE;  // Por si todo falla
  }
